"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUpdating = exports.endUpdate = exports.beginUpdate = exports.instances = void 0;
var on_new_line_1 = __importDefault(require("on-new-line"));
var get_cursor_position_1 = __importDefault(require("get-cursor-position"));
var util = __importStar(require("./util"));
var constants_1 = require("./constants");
var rendering = false;
exports.instances = [];
function beginUpdate() {
    rendering = true;
}
exports.beginUpdate = beginUpdate;
function endUpdate() {
    rendering = false;
}
exports.endUpdate = endUpdate;
function isUpdating() {
    return rendering === true;
}
exports.isUpdating = isUpdating;
(0, on_new_line_1.default)(constants_1.stream);
constants_1.stream.on('before:newlines', function (count) {
    if (isUpdating() || exports.instances.length === 0) {
        return;
    }
    var current = get_cursor_position_1.default.sync();
    if (!current) {
        return;
    }
    // did not reach the end, the screen need not scroll up
    if (current.row < constants_1.stream.rows) {
        return;
    }
    var minRow = 1;
    var cursor = exports.instances[0].cursor;
    beginUpdate();
    exports.instances.forEach(function (instance) {
        if (instance.rendered && (!instance.completed || instance.tough)) {
            // clear the rendered bar
            instance.clear();
            instance.originPos.row = Math.max(minRow, instance.originPos.row - count);
            minRow += instance.rows;
        }
        else if (instance.rendered &&
            instance.completed &&
            !instance.tough &&
            !instance.archived &&
            !instance.clean) {
            instance.clear();
            instance.originPos.row = -instance.rows;
            instance.colorize(instance.output);
            instance.archived = true;
        }
    });
    // append empty row for the new lines, the screen will scroll up,
    // then we can move the bars to their's new position.
    cursor.moveTo(current.row, current.col).write(util.repeatChar('\n', count));
    exports.instances.forEach(function (instance) {
        if (instance.rendered && (!instance.completed || instance.tough)) {
            instance.colorize(instance.output);
        }
    });
    cursor.moveTo(current.row - count, current.col);
    endUpdate();
});
//# sourceMappingURL=global.js.map