import { Cursor } from 'ansi.js';
import { CursorPosition } from './types';
export interface Options {
    total?: number;
    current?: number;
    width?: string | number;
    fixedWidth?: boolean;
    tough?: boolean;
    clean?: boolean;
    schema?: string;
    filled?: string;
    blank?: string;
    callback?: (progressBar: ProgressBar) => void;
}
export declare class ProgressBar {
    readonly cursor: Cursor;
    readonly total: number;
    readonly width: number;
    readonly fixedWidth: boolean;
    readonly clean: boolean;
    readonly blankChar: string;
    readonly fillChar: string;
    readonly tough: boolean;
    readonly callback: (progressBar: ProgressBar) => void;
    raw: string;
    output: string;
    schema: string;
    current: number;
    completed: boolean;
    rows: number;
    savedPos: CursorPosition;
    originPos: CursorPosition;
    rendered: boolean;
    archived: boolean;
    private start;
    constructor(options?: Options);
    setSchema(schema?: string, refresh?: boolean): void;
    tick(): this;
    tick(delta: number): this;
    tick(tokens: Record<string, any>): this;
    tick(delta: number, tokens?: Record<string, any>): this;
    update(ratio: number, tokens?: object): this;
    clear(): this;
    protected compile(tokens?: boolean | Record<string, any>): void;
    protected render(output: string): void;
    colorize(output: string): void;
    protected snoop(): boolean;
    protected terminate(): void;
}
