import { Cursor } from 'ansi.js';
import { RGB } from './types';
export declare function toFixed(value: number, precision: number): string;
export declare function formatTime(ms: number): string;
export declare function ucFirst(str: string): string;
export declare function repeatChar(char: string, count: number): string;
export declare function parseMethod(cursor: Cursor, str: string): BgMethod | FontMethod | GradientMethod | undefined;
export declare type BgMethod = {
    isBg: boolean;
    method: string;
    suffix: string;
};
export declare type FontMethod = {
    isFont: boolean;
    method: string;
    suffix: string;
};
export declare type GradientMethod = {
    method: 'gradient';
    color1: RGB;
    color2: RGB;
};
export declare function parseGradient(str: string): GradientMethod | undefined;
export declare function interpolate(color1: RGB, color2: RGB, percent: number): {
    r: number;
    g: number;
    b: number;
};
export declare function bleach(output: string): string;
export declare function combine(output: string, filled: string, blank: string, bare: boolean): string;
export declare function bareLength(output: string): number;
